// avr-gcc -Os -g -flto -fuse-linker-plugin -Wl,--gc-sections -mmcu=atmega328p -o v10_7.ino.elf v10_7.ino.cpp.o core.a -lm
// avr-objcopy -O ihex -j .eeprom --set-section-flags=.eeprom=alloc,load --no-change-warnings --change-section-lma .eeprom=0 v10_7.ino.elf v10_7.ino.eep
// avr-objcopy -O ihex -R .eeprom v10_7.ino.elf v10_7.ino.hex
// avr-size" -A v10_7.ino.elf
// 
// arduino --verify "%d/%f" --board arduino:avr:uno
// arduino --verify --verbose-build "%d/%f" --board arduino:avr:uno
// "C:\Program Files (x86)\Arduino\hardware\tools\avr\bin\avrdude" -CC:\Users\john\AppData\Local\Arduino15\packages\arduino\tools\avrdude\6.3.0-arduino17/etc/avrdude.conf -v -patmega328p -cusbasp -Pusb -Uflash:w:C:\arduino_build\%f.hex:i 
// avrdude -CC:\avrdude.conf -v -patmega328p -cusbasp -Pusb -Uflash:w:C:\arduino_build\%f.hex:i 
// gcc -std=c99 foo.c -o foo
//
// Небольшое замечание: все отступы в Makefile делаются символами табуляции (клавишей Tab). 
// Если ваш текстовый редактор заменяет эти символы пробелами, команда make откажется собирать проект.
///////////////////////////////////////////////////////////////////////
// http://www.engbedded.com/fusecalc/
// arduino uno        -U lfuse:w:0xff:m -U hfuse:w:0xda:m -U efuse:w:0xfd:m
//
// ====================================================================
// Ещё раз нормально работает на пинах: PB2 = latch, PB3 = data, PB5 = clock
// STCP - > SS   PB2(10(16)) | latch    |pin12 74hc595        |ST_CP  12 | RCLK   | стробирование/защёлка
// DS   - > MOSI PB3(11(17)) | data     |pin14 74hc595 первый |DS     14 | SER    | данные
// SHCP - > SCK  PB5(13(19)) | clock    |pin11 74hc595        |SH_CP  11 | SRCLK  | тактирование
// MR   - > VCC  | |
// OE   - > GND  | |
// ====================================================================
// https://habr.com/ru/post/453276/    Arduino и прерывания таймера
// https://radiokot.ru/forum/viewtopic.php?f=57&t=108443    Помогите ужать програаму, немного не влезает в ATTiny13
// http://blindage.org/?p=2824    Вывод информации на семисегментные индикаторы на примере 4-х индикаторов АЛ304Г
// https://narodstream.ru/avr-urok-27-spi-led-dinamicheskaya-indikaciya/    SPI. LED – динамическая индикация
// https://alexgyver.ru/lessons/bitmath/     Битовые операции   https://alexgyver.ru/lessons/progmem/    Работа с PROGMEM памятью
//
// ====================================================================
//
// avr-gcc -Wall -Os -DF_CPU=16000000UL -mmcu=atmega328p v10c_8.c -o v10c_8.o
// avr-objcopy -j .text -j .data -O ihex v10c_8.o v10c_8.hex
// avrdude -p atmega328p -c usbasp -U flash:w:v10c_8.hex:i
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
unsigned char n_count=0;
// n_count от 0 до 9 проходит один раз за прерывание по нужным катодам
uint8_t segm[2][5] = { 
    {0,0,0,0,10},
    {0,0,0,0,10}
};

uint8_t const DigiMass [] PROGMEM = {
    0b01110111, // два 1й -нижний и 1-верхний
    0b10111011, //
    0b11011101, //
    0b11101110,  //
    0b11011110 //  место точкЕК низ и верх

};
// ABCEDFGH
uint8_t const SegmMass [] PROGMEM = {
    0b01110111, //  0  // ноль
    0b00010100, //  1  // один
    0b01101101, //  2  // два
    0b00111101, //  3  // три
    0b00011110, //  4  // четыре
    0b00111011, //  5  // пять
    0b01111011, //  6  // шесть
    0b00010101, //  7  // семь
    0b01111111, //  8  // восемь
    0b00011111, //  9  // без загогулины, нормальная = 0b00111111
    0b10000000, // 10  // точка
    0b00000000  // 11  // пусто
};  
void int2segm (uint16_t cifra1, uint16_t cifra2);
// ====================================================================
int main(void) {
// инициализация портов сдвигового регистра  SPI  ======================
    DDRB  |=  (1<<PB5);      // линия тактирования   clock
    DDRB  |=  (1<<PB3);      // линия данных         data
    DDRB  |=  (1<<PB2);      // линия стробирования  latch                   // или краткая запись  DDRB  |=  ((1<<PB2)|(1<<PB3)|(1<<PB5)); //ножки SPI на выход
    PORTB &= ~(1<<PB2);      // подать низ на .. линия стробирования  latch
    PORTB &= ~(1<<PB3);      // подать низ на .. линия данных         data
    PORTB &= ~(1<<PB5);      // подать низ на .. линия тактирования   clock  // или краткая запись  PORTB &= ~((1<<PB2)|(1<<PB3)|(1<<PB5)); // низкий уровень
    SPCR  =   ((1<<SPE)|(1<<MSTR)); // включим шину, объявим ведущим
// ====================================================================
// настройка прерываний по таймеру 1000 Гц =============================
    TCCR1A  = 0; TCCR1B = 0;                       // установить регистры в 0
    OCR1A   = 250 - 1;                             // установка регистра совпадения  250 - 1; 
    TCCR1B |= (1 << WGM12);                        // включить CTC режим 
    TCCR1B |= (1 << CS11); TCCR1B |= (1 << CS10);  // включить делитель /64
    TIMSK1 |= (1 << OCIE1A);                       // включить прерывание по совпадению таймера 
    sei();                                         // включить глобальные прерывания
// ====================================================================
    int i,k=0;
    while(1) {
        for (i=0; i<10000; i++) {
        k = k+10;
            int2segm (i, k);
            _delay_ms(100);
            if (k>9999) k=0;
        }
    }
 return 0;
} // main
// ====================================================================
ISR(TIMER1_COMPA_vect) {
    SPDR = pgm_read_byte(&DigiMass[n_count]); while(!(SPSR & (1<<SPIF))); // катоды/аноды
    SPDR = pgm_read_byte(&SegmMass[segm[1][n_count]]); while(!(SPSR & (1<<SPIF))); //верх
    SPDR = pgm_read_byte(&SegmMass[segm[0][n_count]]); while(!(SPSR & (1<<SPIF))); //низ
    PORTB |= (1<<PB2); asm ("nop"); PORTB &= ~(1<<PB2);
    n_count++;
    if (n_count>4) n_count=0;
}
// ====================================================================
void int2segm (uint16_t digit_up, uint16_t digit_dn) {
    segm[0][0] = digit_up/1000;       // up 1
    segm[0][1] = digit_up%1000/100;   // up 2
    segm[0][2] = digit_up%100/10;     // up 3
    segm[0][3] = digit_up%10;         // up 4


    segm[1][0] = digit_dn/1000;       // dn 1
    segm[1][1] = digit_dn%1000/100;   // dn 2
    segm[1][2] = digit_dn%100/10;     // dn 3
    segm[1][3] = digit_dn%10;         // dn 4
}
// ====================================================================
/*
//void indicator_natural2 (unsigned int cifra) { 
void int2segm (uint16_t digit_up, uint16_t digit_dn) {
    uint8_t C0=0, C1=0, C2=0, C3=0, //индексы для массива знаков
            C4=0, C5=0, C6=0, C7=0;
    while(digit_up > 0) {
        if (digit_up > 1000) {
            digit_up = digit_up - 1000; //отнимаем тысячи
            C3++;
        } else {
            if (digit_up > 100) {
                digit_up = digit_up - 100; //отнимаем сотни
                C2++;
            } else {
                if (digit_up > 10) {
                    digit_up = digit_up - 10; //отнимаем десятки
                    C1++;
                } else {
                    if (digit_up > 0) {
                        digit_up = digit_up - 1; //отнимаем единицы
                        C0++;
                    } 
                }
            }
        }
    }
segm[0] = C0; segm[1] = C1; segm[2] = C2; segm[3] = C3;

    while(digit_dn > 0) {
        if (digit_dn > 1000) {
            digit_dn = digit_dn - 1000; //отнимаем тысячи
            C7++;
        } else {
            if (digit_dn > 100) {
                digit_dn = digit_dn - 100; //отнимаем сотни
                C6++;
            } else {
                if (digit_dn > 10) {
                    digit_dn = digit_dn - 10; //отнимаем десятки
                    C5++;
                } else {
                    if (digit_dn > 0) {
                        digit_dn = digit_dn - 1; //отнимаем единицы
                        C4++;
                    } 
                }
            }
        }
    }

segm[4] = C4; segm[5] = C5; segm[6] = C6; segm[7] = C7;
// если первая цифра 0, то не зажигаем ничего. последний 0 будет показываться!
//    R0 = C0; R1 = C1; R2 = C2; R3 = C3;
 //if (C0 == 0) { R0=11; } else { R0 = C0; }
 //if ((C0 + C1) == 0)  { R0=R1=11; } { R0 = C0; R1 = C1;  }
 //if ((C0 + C1 + C2) == 0)  { R0=R1=R2=11; } else { R0 = C0; R1 = C1; R2 = C2; }
}
*/
// ====================================================================
// ============================================================ the end
// ====================================================================
